
/**************************************************************************
07/07/2011 versione 2 della pianola, basata sull'utilizzo degli interrupt	
**************************************************************************/

#include "dsk6713_aic23.h"
Uint32 fs=DSK6713_AIC23_FREQ_96KHZ;

#include <stdio.h>
#include <string.h>
#include <math.h>

#define left 0
#define right 1
#define PI 3.141592654
#define N 25000

short Rchannel[N];
short Lchannel[N];
short Lsample[90];
short Rsample[90];
short dato;
int old_tone=400;
int new_tone=400;
int ts=0;

int tone=0;

int k=0,t=0,max=0,index_max=0,m;
int i=0,j=0;
char flag=0;


union {Uint32 combo; short channel[2];} AIC23_data;
void detect_delay(short *vector_1, short *vector_2);
void shift_right( int *z);


float coef=0;
int freq=440;


interrupt void c_int11()
{
	AIC23_data.combo = input_sample();
	Rchannel[i] = IIR_filterR(AIC23_data.channel[right]);
	Lchannel[i] = IIR_filterL(AIC23_data.channel[left]);
	dato = 1000*sin(coef*i);
	if(freq != 400)
		output_sample(dato);
	else
		output_sample(0);
	i++;
	if( i == (25*96000/freq)){ // si cambia nota solo se siamo a multipli del periodo 
							 // del segnale attualmente generato ( ogni 25 periodi).
		i=0;
		flag=1;
	}
}





void main() {
	
	comm_intr();
	DSK6713_LED_init();
	DSK6713_DIP_init();

	coef=PI*freq/48000;

	while(1)
	{
		if(flag)
		{
			for(m=0;m<90;m++)
			{
				Lsample[m]=Lchannel[2000+m];
				Rsample[m]=Rchannel[2000+m];
			}
			detect_delay(Rsample,Lsample);
		flag=0;
		}
	}
}
		




void detect_delay(short *vector_1, short *vector_2)
{
	 int Convolution[40];
	 int x[130];
	 int y[130];
	
	int k=0,t=0,max=0,index_max=0;

	DSK6713_LED_on(0);
	//init Convolution:
	for(k=0;k<40;k++)
		Convolution[k]=0;
	//vector_1 si lascia dov', si aggiungono 20 zeri all'inizio e alla fine
	for(k=0;k<20;k++)
		x[k]=0;
	for(k=20;k<110;k++)
		x[k]=vector_1[k-20];
	for(k=110;k<130;k++)
		x[k]=0;

	//vector_2 si sposta a sinistra di 20 e poi si shifta di 1 campione alla volta
	for(k=0;k<90;k++)
		y[k]=vector_2[k];
	for(k=90;k<130;k++)
		y[k]=0;

	for(k=0;k<40;k++)// 40 spostamenti del vettore y
	{
		for(t=0;t<130;t++)
			Convolution[k]=Convolution[k]+x[t]*y[t];
		shift_right(y);// esegue uno shift a destra del vettore
	}

	for(m=0;m<40;m++)
	{
		if(Convolution[m]>= max)
			{	max=Convolution[m];
				index_max=m;
				}
	}

	tone=index_max; 

	if(tone>0 && tone <7)
		freq=440; //LA
	else if(tone >=7 && tone <11)
		freq=494; //SI
	else if(tone >=11 && tone <17)
		freq=523; //DO
	else if(tone >=17 && tone <21)
		freq=587; //RE
	else if(tone >=21 && tone <28)
		freq=659; //MI
	else if(tone >=28 && tone <33)
		freq=698; //FA
	else if(tone >=33 && tone <38)
		freq=784; //SOL
	else freq=400; // se freq = 400, viene spento l'audio.


	new_tone=freq;
	if(new_tone != old_tone) // si passa al tono successivo se si  presentato per 4 volte consecutive!
	{	
		ts++;
		if(ts>=3)
		{
			ts=0;
			old_tone=new_tone;
		}
	}
	else 
		ts=0;

	freq=old_tone;

	coef=PI*freq/48000;

	DSK6713_LED_off(0);
}


void shift_right(  int *z)
{
	int k=0;
	for(k=129;k>0;k--)
		z[k]=z[k-1];
	z[0]=0;
}
		

		









